\ boot.asm
\
\ Boot code for MTV 

\ Protocol:
\
\ To execute a command, the PC should:
\
\ (1) Send a command byte.
\ (2) Send parameters/data.
\ (3) Wait for the command byte to echo.
\
\ When whole words (4 bytes) are sent, the most significant byte is sent first.
\
\ Commands.
\
\ Nr	Command					Parameters / return values
\
\ 0	Push address				address (4 bytes) - /
\ 1	Drop address				- / -
\ 2	Read byte, increment address		- / byte
\ 3	Store byte, increment address		byte / -
\ 4	Execute code				address / -
\ 5	Write dirty flash buffers		- / -
\
\ Note that we JUMP to the code, we don't CALL it. To return to the "boot
\ monitor", reboot or jump to 0x01000000.


fload f.f
start

0 syscall init
1 syscall poll
2 syscall receive
3 syscall send
4 syscall freeram
5 syscall sync-flash

: read-word  receive receive receive receive ;
: command  receive
  is0           read-word >a send ;  then
  dup 1 # = if  adrop send ;  then
  dup 2 # = if  c@+ send send ;  then
  dup 3 # = if  receive c!+ send ;  then
  dup 4 # = if  send read-word 0 jumpf  then
  dup 5 # = if  sync-flash send ;  then drop ;

entry:
: main  $17 # init  { command }

save boot.bin
bye

